Subiject: QOM logicalNot() does not work as expected

Description

$query->logicalNot() seems to be completely ignored. To reproduce that bug you can add a new constraint to the query in
BlogRepository->findByBlog():

This works as expected (only posts with the title "FLOW3" are returned):

$query->matching($query->logicalAnd($query->equals('blog’, $blog), $query->equals(‘title', 'FLOW3')))...

This query should return all posts, but not the ones having "FLOW3" as title:

$query->matching($query->logicalAnd($query->equals('blog’, $blog), $query->logicalNot($query->equals('itle', 'FLOWI'))))...

The second query ignores the title constraint and returns all posts.

Associated revisions

Revision 7dd5ad24 - 2010-06-25 14:25 - Karsten Dambekalns

[+BUGFIX] FLOWS3 (Persistence): logicalNot() now works, fixes #8411. Some code cleanup along the way.

History

#1 - 2010-06-21 17:29 - Karsten Dambekalns
- Status changed from New to Accepted

- Start date deleted (2010-06-21)

#2 - 2010-06-23 12:41 - Karsten Dambekalns
- Target version set to 1.0 alpha 10

- Start date set to 2010-06-23

#3 - 2010-06-24 17:07 - Karsten Dambekalns
- Estimated time set to 3.00

Ok, confirmed. Here's the problem:

To check a value of a certain property we use this logic:
... AND (field = 'title' AND value = 'Test')

Now we wrap this in logicalNot(), basically doing what it should:
.. AND (NOT (field = 'title’ AND value = 'Test) )

But, we mean:
... AND (field = 'title' AND NOT (value = 'Test') )

#4 - 2010-06-25 14:30 - Karsten Dambekalns
- Status changed from Accepted to Resolved
- % Done changed from 0 to 100

Applied in changeset r4636.
